//  Copyright (c) 2012 Dennco Project
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

//
//  Created by tkawata on 1/2/2012.
//

#include "ConsoleUIOut.h"
#import "Controller.h"

void ConsoleUIOut::vprintf(const char *fmt, va_list ap)
{
	NSString *nfmt = [[NSString alloc]initWithCString:fmt
                                             encoding:NSUTF8StringEncoding];
	NSString *str = [[NSString alloc]initWithFormat:nfmt arguments:ap];
    
    str = [str stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
    str = [str stringByAppendingString:@"\n"];
    
    if (mView && str)
    {
        NSAttributedString *astr = [[NSAttributedString alloc]initWithString:str];
        NSTextStorage *storage = [mView textStorage];
        [storage performSelectorOnMainThread:@selector(appendAttributedString:) withObject:astr waitUntilDone:NO];
        [mController performSelectorOnMainThread:@selector(showConsoleBottom) withObject:nil waitUntilDone:NO];
    }
#ifdef DEBUG
    NSLog(@"%@", str);
#endif
}

void ConsoleUIOut::vDebugPrintf(const char *fmt, va_list ap)
{
	NSString *nfmt = [[NSString alloc]initWithCString:fmt
                                             encoding:NSUTF8StringEncoding];
	NSString *str = [[NSString alloc]initWithFormat:nfmt arguments:ap];
	NSLog(@"DEBUG:%@",str);
}

void ConsoleUIOut::clearAll()
{
    [mView performSelectorOnMainThread:@selector(setString:) withObject:@"" waitUntilDone:NO];
}